# Модуль decort_account_info
## Обзор модуля

Модуль **decort_account_info** предназначен для получения следующей информации об аккаунте:
- **основная информация** (см. [возвращаемые значения](#основная-информация) и [примеры](#получение-основной-информации-об-аккаунте))
- **используемые и зарезервированные ресурсы** (см. [параметр resource_consumption](#resource_consumption), [возвращаемые значения](#используемые-и-зарезервированные-ресурсы) и [примеры](#получение-информации-об-используемых-и-зарезервированных-ресурсах-аккаунта))
- **ресурсные группы** (см. [параметр resource_groups](#resource_groups), [возвращаемые значения](#ресурсные-группы) и [примеры](#получение-информации-о-ресурсных-группах))
- **виртуальные машины** (см. [параметр computes](#computes), [возвращаемые значения](#виртуальные-машины) и [примеры](#получение-информации-о-виртуальных-машинах))
- **внутренние сети** (см. [параметр vinses](#vinses), [возвращаемые значения](#внутренние-сети) и [примеры](#получение-информации-о-внутренних-сетях))
- **диски** (см. [параметр disks](#disks), [возвращаемые значения](#диски) и [примеры](#получение-информации-о-дисках))
- **доступные образы** (см. [параметр images](#param_images), [возвращаемые значения](#образы) и [примеры](#получение-информации-об-образах))
- **группы с плавающим IP-адресом** (см. [параметр flip_groups](#flip_groups), [возвращаемые значения](#группы-с-плавающим-ip-адресом) и [примеры](#получение-информации-о-группах-с-плавающим-ip-адресом))
- **аудиты** (см. [параметр audits](#audits), [возвращаемые значения](#аудиты) и [примеры](#получение-информации-об-аудитах))

## Параметры модуля 
Ниже приведен список параметров для модуля **decort_account_info** (за исключением [общих параметров авторизации](./введение.md#общие-параметры-модулей-для-авторизации)):

<table>
  <tr>
    <th colspan="6">Параметр</th>
    <th>Тип</th>
    <th>Описание</th>
  </tr>
  <tr>
    <td colspan="6">
      <a name="audits">
        audits
      </a>
    </td>
    <td>
      (bool)
      <br>Default: <code>false</code>
    </td>
    <td>
      Получить информацию об аудитах.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      <a name="computes">
        computes
      </a>
    </td>
    <td>
      (dict)
    </td>
    <td>
      Получить информацию о виртуальных машинах, к которым имеет доступ пользователь,
        с учётом заданных параметров вывода.
      <br> Чтобы получить информацию без использования параметров вывода,
      необходимо задать пустой словарь <code>{}</code>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      filter
    </td>
    <td>
      (dict)
    </td>
    <td>
      Фильтр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      ext_net_id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору внешней сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      ext_net_name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени внешней сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      ip
    </td>
    <td>
      (str)
    </td>
    <td>
      По IP-адресу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      rg_id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору ресурсной группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      rg_name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени ресурсной группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      tech_status
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>BACKUP_RUNNING</code>
      <br><code>BACKUP_STOPPED</code>
      <br><code>DOWN</code>
      <br><code>MIGRATING</code>
      <br><code>PAUSED</code>
      <br><code>PAUSING</code>
      <br><code>SCHEDULED</code>
      <br><code>STARTED</code>
      <br><code>STARTING</code>
      <br><code>STOPPED</code>
      <br><code>STOPPING</code>
    </td>
    <td>
      По техническому статусу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      pagination
    </td>
    <td>
      (dict)
    </td>
    <td>
      Постраничный вывод.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      number
    </td>
    <td>
      (int)
      <br>Default: <code>1</code>
    </td>
    <td>
      Номер страницы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      size
    </td>
    <td>
      (int)
    </td>
    <td>
      Размер страниц.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      sorting
    </td>
    <td>
      (dict)
    </td>
    <td>
      Сортировка.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      asc
    </td>
    <td>
      (bool)
      <br>Default: <code>true</code>
    </td>
    <td>
      Сортировать по возрастанию.
      <br><code>true</code> - по возрастанию.
      <br><code>false</code> - по убыванию.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      field
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>cpus</code>
      <br><code>createdBy</code>
      <br><code>createdTime</code>
      <br><code>deletedBy</code>
      <br><code>deletedTime</code>
      <br><code>id</code>
      <br><code>name</code>
      <br><code>ram</code>
      <br><code>registered</code>
      <br><code>rgId</code>
      <br><code>rgName</code>
      <br><code>status</code>
      <br><code>techStatus</code>
      <br><code>totalDisksSize</code>
      <br><code>updatedBy</code>
      <br><code>updatedTime</code>
      <br><code>userManaged</code>
      <br><code>vinsConnected</code>
    </td>
    <td>
      Название поля, по которому сортировать.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      <a name="disks">
        disks
      </a>
    </td>
    <td>
      (dict)
    </td>
    <td>
      Получить информацию о неподключённых дисках, к которым имеет доступ пользователь,
        с учётом заданных параметров вывода.
      <br> Чтобы получить информацию без использования параметров вывода,
      необходимо задать пустой словарь <code>{}</code>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      filter
    </td>
    <td>
      (dict)
    </td>
    <td>
      Фильтр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      size
    </td>
    <td>
      (int)
    </td>
    <td>
      По объёму.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      type
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>B</code>
      <br><code>D</code>
    </td>
    <td>
      По типу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      pagination
    </td>
    <td>
      (dict)
    </td>
    <td>
      Постраничный вывод.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      number
    </td>
    <td>
      (int)
      <br>Default: <code>1</code>
    </td>
    <td>
      Номер страницы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      size
    </td>
    <td>
      (int)
    </td>
    <td>
      Размер страниц.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      sorting
    </td>
    <td>
      (dict)
    </td>
    <td>
      Сортировка.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      asc
    </td>
    <td>
      (bool)
      <br>Default: <code>true</code>
    </td>
    <td>
      Сортировать по возрастанию.
      <br><code>true</code> - по возрастанию.
      <br><code>false</code> - по убыванию.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      field
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>id</code>
      <br><code>name</code>
      <br><code>pool</code>
      <br><code>sepId</code>
      <br><code>shareable</code>
      <br><code>sizeMax</code>
      <br><code>type</code>
    </td>
    <td>
      Название поля, по которому сортировать.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      <a name="flip_groups">
        flip_groups
      </a>
    </td>
    <td>
      (dict)
    </td>
    <td>
      Получить информацию о группах с плавающим IP-адресом, к которым имеет
      доступ пользователь, с учётом заданных параметров вывода.
      <br> Чтобы получить информацию без использования параметров вывода,
      необходимо задать пустой словарь <code>{}</code>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      filter
    </td>
    <td>
      (dict)
    </td>
    <td>
      Фильтр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      ext_net_id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору внешней сети.
    </td>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      ip
    </td>
    <td>
      (str)
    </td>
    <td>
      По IP-адресу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      vins_id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору внутренней сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      vins_name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени внутренней сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      pagination
    </td>
    <td>
      (dict)
    </td>
    <td>
      Постраничный вывод.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      number
    </td>
    <td>
      (int)
      <br>Default: <code>1</code>
    </td>
    <td>
      Номер страницы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      size
    </td>
    <td>
      (int)
    </td>
    <td>
      Размер страниц.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      id
    </td>
    <td>
      (int)
    </td>
    <td>
      Идентификатор целевого аккаунта.
      <br> Обязательный параметр, если не задан параметр
        <code>name</code>.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      <a name="param_images">
        images
      </a>
    </td>
    <td>
      (dict)
    </td>
    <td>
      Получить информацию об образах, которые доступны к использованию
        в аккаунте, с учётом заданных параметров вывода.
      <br> Чтобы получить информацию без использования параметров вывода,
      необходимо задать пустой словарь <code>{}</code>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      filter
    </td>
    <td>
      (dict)
    </td>
    <td>
      Фильтр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      type
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>cdrom</code>
      <br><code>linux</code>
      <br><code>other</code>
      <br><code>virtual</code>
      <br><code>windows</code>
    </td>
    <td>
      По типу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      pagination
    </td>
    <td>
      (dict)
    </td>
    <td>
      Постраничный вывод.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      number
    </td>
    <td>
      (int)
      <br>Default: <code>1</code>
    </td>
    <td>
      Номер страницы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      size
    </td>
    <td>
      (int)
    </td>
    <td>
      Размер страниц.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      sorting
    </td>
    <td>
      (dict)
    </td>
    <td>
      Сортировка.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      asc
    </td>
    <td>
      (bool)
      <br>Default: <code>true</code>
    </td>
    <td>
      Сортировать по возрастанию.
      <br><code>true</code> - по возрастанию.
      <br><code>false</code> - по убыванию.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      field
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>UNCPath</code>
      <br><code>desc</code>
      <br><code>id</code>
      <br><code>name</code>
      <br><code>public</code>
      <br><code>size</code>
      <br><code>status</code>
      <br><code>type</code>
      <br><code>username</code>
    </td>
    <td>
      Название поля, по которому сортировать.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      name
    </td>
    <td>
      (str)
    </td>
    <td>
      Имя целевого аккаунта.
      <br>Может быть альтернативой параметру <code>id</code>,
        за исключением случая, когда необходимо получить
        информацию о безвозвратно удалённом объекте.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      <a name="resource_groups">
        resource_groups
      </a>
    </td>
    <td>
      (dict)
    </td>
    <td>
      Получить информацию о ресурсных группах, к которым имеет доступ пользователь,
        с учётом заданных параметров вывода.
      <br> Чтобы получить информацию без использования параметров вывода,
      необходимо задать пустой словарь <code>{}</code>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      filter
    </td>
    <td>
      (dict)
    </td>
    <td>
      Фильтр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      status
    </td>
    <td>
      (str)
      <br> Значения:
      <br><code>CREATED</code>
      <br><code>DELETED</code>
      <br><code>DELETING</code>
      <br><code>DESTROYED</code>
      <br><code>DESTROYING</code>
      <br><code>DISABLED</code>
      <br><code>DISABLING</code>
      <br><code>ENABLED</code>
      <br><code>ENABLING</code>
      <br><code>MODELED</code>
      <br><code>RESTORING</code>
    </td>
    <td>
      По статусу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      vins_id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору внутренней сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      vm_id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору виртуальной машины.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      pagination
    </td>
    <td>
      (dict)
    </td>
    <td>
      Постраничный вывод.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      number
    </td>
    <td>
      (int)
      <br>Default: <code>1</code>
    </td>
    <td>
      Номер страницы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      size
    </td>
    <td>
      (int)
    </td>
    <td>
      Размер страниц.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      sorting
    </td>
    <td>
      (dict)
    </td>
    <td>
      Сортировка.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      asc
    </td>
    <td>
      (bool)
      <br>Default: <code>true</code>
    </td>
    <td>
      Сортировать по возрастанию.
      <br><code>true</code> - по возрастанию.
      <br><code>false</code> - по убыванию.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      field
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>createdBy</code>
      <br><code>createdTime</code>
      <br><code>deletedBy</code>
      <br><code>deletedTime</code>
      <br><code>id</code>
      <br><code>milestones</code>
      <br><code>name</code>
      <br><code>status</code>
      <br><code>updatedBy</code>
      <br><code>updatedTime</code>
      <br><code>vinses</code>
    </td>
    <td>
      Название поля, по которому сортировать.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      <a name="resource_consumption">
        resource_consumption
      </a>
    </td>
    <td>
      (bool)
      <br>Default: <code>false</code>
    </td>
    <td>
      Получить информацию об используемых и зарезервированных ресурсах.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      <a name="vinses">
        vinses
      </a>
    </td>
    <td>
      (dict)
    </td>
    <td>
      Получить информацию о внутренних сетях, к которым имеет доступ пользователь,
        с учётом заданных параметров вывода.
      <br> Чтобы получить информацию без использования параметров вывода,
      необходимо задать пустой словарь <code>{}</code>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      filter
    </td>
    <td>
      (dict)
    </td>
    <td>
      Фильтр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      ext_ip
    </td>
    <td>
      (str)
    </td>
    <td>
      По внешнему IP-адресу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      name
    </td>
    <td>
      (str)
    </td>
    <td>
      По имени.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      rg_id
    </td>
    <td>
      (int)
    </td>
    <td>
      По идентификатору ресурсной группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      pagination
    </td>
    <td>
      (dict)
    </td>
    <td>
      Постраничный вывод.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      number
    </td>
    <td>
      (int)
      <br>Default: <code>1</code>
    </td>
    <td>
      Номер страницы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      size
    </td>
    <td>
      (int)
    </td>
    <td>
      Размер страниц.
      <br> Обязательный параметр.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      sorting
    </td>
    <td>
      (dict)
    </td>
    <td>
      Сортировка.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      asc
    </td>
    <td>
      (bool)
      <br>Default: <code>true</code>
    </td>
    <td>
      Сортировать по возрастанию.
      <br><code>true</code> - по возрастанию.
      <br><code>false</code> - по убыванию.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      field
    </td>
    <td>
      (str)
      <br>Значения:
      <br><code>computes</code>
      <br><code>createdBy</code>
      <br><code>createdTime</code>
      <br><code>deletedBy</code>
      <br><code>deletedTime</code>
      <br><code>externalIP</code>
      <br><code>extnetId</code>
      <br><code>freeIPs</code>
      <br><code>id</code>
      <br><code>name</code>
      <br><code>network</code>
      <br><code>priVnfDevId</code>
      <br><code>rgId</code>
      <br><code>rgName</code>
      <br><code>status</code>
      <br><code>updatedBy</code>
      <br><code>updatedTime</code>
    </td>
    <td>
      Название поля, по которому сортировать.
      <br> Обязательный параметр.
    </td>
  </tr>
</table>

## Возвращаемые значения

Модуль **decort_account_info** возвращает информацию об аккаунте в виде словаря `facts` со следующими ключами:

### Основная информация

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      acl
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих доступы пользователей.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      canBeDeleted
    </td>
    <td>
      bool
    </td>
    <td>
      Может ли быть удалён.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      right
    </td>
    <td>
      str
    </td>
    <td>
      Права.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      status
    </td>
    <td>
      str
    </td>
    <td>
      Статус.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      type
    </td>
    <td>
      str
    </td>
    <td>
      Тип.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      userGroupId
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя или группы пользователей.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      company
    </td>
    <td>
      str
    </td>
    <td>
      Название компании.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      companyurl
    </td>
    <td>
      str
    </td>
    <td>
      URL компании.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      computeFeatures
    </td>
    <td>
      list
    </td>
    <td>
      Список дополнительных возможностей гипервизора, доступных ВМ.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      computes_amount
    </td>
    <td>
      dict
    </td>
    <td>
      Количество ВМ по состоянию.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      started
    </td>
    <td>
      int
    </td>
    <td>
      Количество запущенных ВМ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      stopped
    </td>
    <td>
      int
    </td>
    <td>
      Количество остановленных ВМ.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      cpu_allocation_parameter
    </td>
    <td>
      str
    </td>
    <td>
      Режим выделения ЦП.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      cpu_allocation_ratio
    </td>
    <td>
      str
    </td>
    <td>
      Коэффициент для режима выделения ЦП.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      createdBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который создал.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      createdTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время создания.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      createdTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время создания.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      deactivationTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время выключения.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      deactivationTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время выключения.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      deletedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который удалил.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      deletedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время удаления.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      deletedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время удаления.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      description
    </td>
    <td>
      str
    </td>
    <td>
      Описание.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      displayname
    </td>
    <td>
      str
    </td>
    <td>
      Отображаемое имя.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      id
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      name
    </td>
    <td>
      str
    </td>
    <td>
      Имя.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      resourceLimits
    </td>
    <td>
      dict
    </td>
    <td>
      Квоты на ресурсы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      CU_C
    </td>
    <td>
      int
    </td>
    <td>
      Количество виртуальных процессоров.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      CU_D
    </td>
    <td>
      int
    </td>
    <td>
      Объём диска в ГБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      CU_DM
    </td>
    <td>
      int
    </td>
    <td>
      Объём дисков в ГБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      CU_I
    </td>
    <td>
      int
    </td>
    <td>
      Количество внешних IP-адресов.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      CU_M
    </td>
    <td>
      float
    </td>
    <td>
      Объём оперативной памяти в МБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      CU_NP
    </td>
    <td>
      int
    </td>
    <td>
      Объём трафика внешних сетей.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      gpu_units
    </td>
    <td>
      int
    </td>
    <td>
      Количество графических процессоров.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      sendAccessEmails
    </td>
    <td>
      bool
    </td>
    <td>
      Отправка пользователям на эл. почту уведомлений о предоставлении доступа.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      status
    </td>
    <td>
      str
    </td>
    <td>
      Статус.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      uniqPools
    </td>
    <td>
      list
    </td>
    <td>
      Список доступных пулов СХД.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      updatedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время обновления.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      updatedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время обновления.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      vins
    </td>
    <td>
      list
    </td>
    <td>
      Список идентификаторов внутренних сетей на уровне аккаунта.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      vinses_amount
    </td>
    <td>
      int
    </td>
    <td>
      Количество внутренних сетей.
    </td>
  </tr>
</table>

### Используемые и зарезервированные ресурсы

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      <a name="resource_consumed">
        resource_consumed
      </a>
    </td>
    <td>
      dict
    </td>
    <td>
      Используемые ресурсы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      cpu
    </td>
    <td>
      int
    </td>
    <td>
      Количество виртуальных процессоров.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      disksize
    </td>
    <td>
      int
    </td>
    <td>
      Объём дисков в ГБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      extips
    </td>
    <td>
      int
    </td>
    <td>
      Количество внешних IP-адресов.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      exttraffic
    </td>
    <td>
      int
    </td>
    <td>
      Объём трафика внешних сетей.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      gpu
    </td>
    <td>
      int
    </td>
    <td>
      Количество графических процессоров.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      ram
    </td>
    <td>
      int
    </td>
    <td>
      Объём оперативной памяти в МБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      seps
    </td>
    <td>
      dict
    </td>
    <td>
      Объём дисков по пулам СХД.
    </td>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      (идентификатор СХД)
    </td>
    <td>
      dict
    </td>
    <td>
      Пулы СХД.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      (название пула)
    </td>
    <td>
      dict
    </td>
    <td>
      Словарь пула СХД.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="2">
      disksize
    </td>
    <td>
      int
    </td>
    <td>
      Объём дисков в ГБ.
    </td>
  </tr>
  <tr>
    <td colspan="6">
      resource_reserved
    </td>
    <td>
      dict
    </td>
    <td>
      Зарезервированные ресурсы.
      <br> Структура словаря аналогична словарю
        <a href=#resource_consumed>
        resource_consumed
        </a>.
    </td>
  </tr>
</table>

### Ресурсные группы

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      resource_groups
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих ресурсные группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      Computes
    </td>
    <td>
      dict
    </td>
    <td>
      Количество ВМ по состоянию.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      Started
    </td>
    <td>
      int
    </td>
    <td>
      Количество запущенных ВМ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      Stopped
    </td>
    <td>
      int
    </td>
    <td>
      Количество остановленных ВМ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      Resources
    </td>
    <td>
      dict
    </td>
    <td>
      Используемые и зарезервированные ресурсы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      Consumed
    </td>
    <td>
      dict
    </td>
    <td>
      Используемые ресурсы.
      <br> Структура словаря аналогична словарю
        <a href=#resource_consumed>
        resource_consumed
        </a>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      Limits
    </td>
    <td>
      dict
    </td>
    <td>
      Квоты на ресурсы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      cpu
    </td>
    <td>
      int
    </td>
    <td>
      Количество виртуальных процессоров.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      disksize
    </td>
    <td>
      int
    </td>
    <td>
      Объём дисков в ГБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      disksizemax
    </td>
    <td>
      int
    </td>
    <td>
      Объём диска в ГБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      extips
    </td>
    <td>
      int
    </td>
    <td>
      Количество внешних IP-адресов.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      exttraffic
    </td>
    <td>
      int
    </td>
    <td>
      Объём трафика внешних сетей.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      gpu
    </td>
    <td>
      int
    </td>
    <td>
      Количество графических процессоров.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td colspan="3">
      ram
    </td>
    <td>
      float
    </td>
    <td>
      Объём оперативной памяти в МБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td></td>
    <td colspan="4">
      Reserved
    </td>
    <td>
      dict
    </td>
    <td>
      Зарезервированные ресурсы.
      <br> Структура словаря аналогична словарю
        <a href=#resource_consumed>
        resource_consumed
        </a>.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который создал.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который удалил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      description
    </td>
    <td>
      str
    </td>
    <td>
      Описание.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      id
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      milestones
    </td>
    <td>
      int
    </td>
    <td>
      Количество событий.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      name
    </td>
    <td>
      str
    </td>
    <td>
      Имя.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      status
    </td>
    <td>
      str
    </td>
    <td>
      Статус.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который обновил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время обновления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время обновления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      vinses
    </td>
    <td>
      int
    </td>
    <td>
      Количество внутренних сетей.
    </td>
  </tr>
</table>

### Виртуальные машины

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      computes
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих виртуальные машины.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      accountId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор аккаунта.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      accountName
    </td>
    <td>
      str
    </td>
    <td>
      Имя аккаунта.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      cpus
    </td>
    <td>
      int
    </td>
    <td>
      Количество виртуальных процессоров.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который создал.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который удалил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      id
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      name
    </td>
    <td>
      str
    </td>
    <td>
      Имя.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      ram
    </td>
    <td>
      int
    </td>
    <td>
      Объём оперативной памяти в МБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      registered
    </td>
    <td>
      bool
    </td>
    <td>
      Зарегистрирована ли ВМ как используемая.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      rgId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор ресурсной группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      rgName
    </td>
    <td>
      str
    </td>
    <td>
      Имя ресурсной группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      status
    </td>
    <td>
      str
    </td>
    <td>
      Статус.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      techStatus
    </td>
    <td>
      str
    </td>
    <td>
      Технический статус.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      totalDisksSize
    </td>
    <td>
      int
    </td>
    <td>
      Общий объём дисков.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который обновил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время обновления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время обновления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      vinsConnected
    </td>
    <td>
      int
    </td>
    <td>
      Количество подключенных внутренних сетей.
    </td>
  </tr>
</table>

### Внутренние сети

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      vinses
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих внутренние сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      accountId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор аккаунта.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      accountName
    </td>
    <td>
      str
    </td>
    <td>
      Имя аккаунта.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      computes
    </td>
    <td>
      int
    </td>
    <td>
      Количество виртуальных машин.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который создал.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который удалил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      externalIP
    </td>
    <td>
      str
    </td>
    <td>
      Внешний IP-адрес.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      extnetId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор внешней сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      freeIPs
    </td>
    <td>
      int
    </td>
    <td>
      Количество свободных IP-адресов.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      id
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      name
    </td>
    <td>
      str
    </td>
    <td>
      Имя.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      network
    </td>
    <td>
      str
    </td>
    <td>
      Адрес сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      priVnfDevId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор виртуального маршрутизатора.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      rgId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор ресурсной группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      rgName
    </td>
    <td>
      str
    </td>
    <td>
      Имя ресурсной группы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      status
    </td>
    <td>
      str
    </td>
    <td>
      Статус.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который обновил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время обновления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время обновления.
    </td>
  </tr>
</table>

### Диски

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      disks
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих диски.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      id
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      name
    </td>
    <td>
      str
    </td>
    <td>
      Имя.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      pool
    </td>
    <td>
      str
    </td>
    <td>
      Пул СХД.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      sepId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор СХД.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      shareable
    </td>
    <td>
      bool
    </td>
    <td>
      Общий доступ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      sizeMax
    </td>
    <td>
      int
    </td>
    <td>
      Объём.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      type
    </td>
    <td>
      str
    </td>
    <td>
      Тип.
    </td>
  </tr>
</table>

### Образы

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      images
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих образы.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      UNCPath
    </td>
    <td>
      str
    </td>
    <td>
      Путь к файлу.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      desc
    </td>
    <td>
      str
    </td>
    <td>
      Описание.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      id
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      name
    </td>
    <td>
      str
    </td>
    <td>
      Имя.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      public
    </td>
    <td>
      bool
    </td>
    <td>
      Общий доступ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      size
    </td>
    <td>
      int
    </td>
    <td>
      Размер в ГБ.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      status
    </td>
    <td>
      str
    </td>
    <td>
      Статус.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      type
    </td>
    <td>
      str
    </td>
    <td>
      Тип.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      username
    </td>
    <td>
      str
    </td>
    <td>
      Имя пользователя.
    </td>
  </tr>
</table>

### Группы с плавающим IP-адресом
<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      flip_groups
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих группы с плавающим IP-адресом.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      clientType
    </td>
    <td>
      str
    </td>
    <td>
      Тип клиентов.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      connType
    </td>
    <td>
      str
    </td>
    <td>
      Тип соединения.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который создал.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      createdTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время создания.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который удалил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      deletedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время удаления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      desc
    </td>
    <td>
      str
    </td>
    <td>
      Описание.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      gid
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор ЦОД.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      id
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      ip
    </td>
    <td>
      str
    </td>
    <td>
      IP-адрес.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      milestones
    </td>
    <td>
      int
    </td>
    <td>
      Количество событий.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      name
    </td>
    <td>
      str
    </td>
    <td>
      Имя.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      netId
    </td>
    <td>
      int
    </td>
    <td>
      Идентификатор сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      netType
    </td>
    <td>
      str
    </td>
    <td>
      Тип сети.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      netmask
    </td>
    <td>
      int
    </td>
    <td>
      Маска подсети (длина префикса).
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      status
    </td>
    <td>
      str
    </td>
    <td>
      Статус.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedBy
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя, который обновил.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime
    </td>
    <td>
      int
    </td>
    <td>
      Unix-время обновления.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      updatedTime_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время обновления.
    </td>
  </tr>
</table>

### Аудиты

<table>
  <tr>
    <th colspan="6">
      Ключ
    </th>
    <th>
      Тип
      <br>данных
    </th>
    <th>
      Описание
    </th>
  </tr>
  <tr>
    <td colspan="6">
      audits
    </td>
    <td>
      list
    </td>
    <td>
      Список словарей, описывающих аудиты.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      call
    </td>
    <td>
      str
    </td>
    <td>
      Метод API.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      responsetime
    </td>
    <td>
      float
    </td>
    <td>
      Время отклика в секундах.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      statuscode
    </td>
    <td>
      int
    </td>
    <td>
      Код ответа.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      timestamp
    </td>
    <td>
      float
    </td>
    <td>
      Unix-время.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      timestamp_readable
    </td>
    <td>
      str
    </td>
    <td>
      Дата и время.
    </td>
  </tr>
  <tr>
    <td></td>
    <td colspan="5">
      user
    </td>
    <td>
      str
    </td>
    <td>
      Идентификатор пользователя.
    </td>
  </tr>
</table>

## Примеры использования

### Получение основной информации об аккаунте

#### По идентификатору
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get basic account info by ID
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
```

#### По имени
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get basic account info by name
      decort_account_info:
        # Параметры для авторизации упущены
        name: "{{ account_name }}"
```

### Получение информации об используемых и зарезервированных ресурсах аккаунта
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with resource consumption
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        resource_consumption: true
```

### Получение информации о ресурсных группах

#### Без использования параметров вывода
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with resource groups
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        resource_groups: {}
```

#### С фильтрацией по статусу
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with resource groups
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        resource_groups:
          filter:
            status: CREATED
```

#### С сортировкой по имени
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with resource groups
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        resource_groups:
          sorting:
            field: name
```

#### С постраничным выводом
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with resource groups
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        resource_groups:
          pagination:
            size: 2
```

### Получение информации о виртуальных машинах

#### Без использования параметров вывода
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with computes
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        computes: {}
```

#### С фильтрацией по IP-адресу
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with computes
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        computes:
          filter:
            ip: 192.168.1.2
```

#### С сортировкой по имени
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with computes
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        computes:
          sorting:
            field: name
```

#### С постраничным выводом
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with computes
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        computes:
          pagination:
            size: 2
```

### Получение информации о внутренних сетях

#### Без использования параметров вывода
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with vinses
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        vinses: {}
```

#### С фильтрацией по идентификатору ресурсной группы
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with vinses
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        vinses:
          filter:
            rg_id: "{{ rg_id }}"
```

#### С сортировкой по времени создания
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with vinses
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        vinses:
          sorting:
            field: createdTime
```

#### С постраничным выводом
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with vinses
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        vinses:
          pagination:
            size: 2
```

### Получение информации о дисках

#### Без использования параметров вывода
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with disks
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        disks: {}
```

#### С фильтрацией по типу
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with disks
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        disks:
          filter:
            type: D
```

#### С сортировкой по объёму
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with disks
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        disks:
          sorting:
            field: sizeMax
```

#### С постраничным выводом
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with disks
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        disks:
          pagination:
            size: 2
```

### Получение информации об образах

#### Без использования параметров вывода
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with images
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        images: {}
```

#### С фильтрацией по типу
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with images
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        images:
          filter:
            type: linux
```

#### С сортировкой по статусу
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with images
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        images:
          sorting:
            field: status
```

#### С постраничным выводом
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with images
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        images:
          pagination:
            size: 2
```

### Получение информации о группах с плавающим IP-адресом

#### Без использования параметров вывода
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with flip groups
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        flip_groups: {}
```

#### С фильтрацией по IP-адресу
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with flip groups
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        flip_groups:
          filter:
            ip: 192.168.1.5
```

#### С постраничным выводом
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with flip groups
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        flip_groups:
          pagination:
            size: 2
```

### Получение информации об аудитах
```
- name: Example
  hosts: localhost
  tasks:
    - name: Get account info with audits
      decort_account_info:
        # Параметры для авторизации упущены
        id: "{{ account_id }}"
        audits: true
```
